/*
 *	Atari cookie-jar definitions
 *
 *	Patrice Mandin
 */
 
#ifndef _I_COOKIES_H_
#define _I_COOKIES_H_

/* Values for _MCH cookie */

#define MCH_ST	0
#define MCH_STE	1
#define MCH_TT	2
#define MCH_F30	3

/* Values for _VDO cookie */

#define VDO_ST	0
#define VDO_STE	1
#define VDO_TT	2
#define VDO_F30	3

/* Bits masks for _SND cookie */

#define SND_YM		0 	/* Yamaha ym2149 */
#define SND_DMA8	1 	/* STE/TT dma sound */
#define SND_DMAREC	2	/* Dma recording functions with xbios */
#define SND_CODEC16	3	/* Falcon 16 bits codec */
#define SND_DSP56K	4 	/* Falcon DSP56001 */

/* variables */

extern long cookie_mch;
extern long cookie_vdo;
extern long cookie_snd;

/* functions */

void I_ScanCookies(void);

#endif
